#procedure threegammastoepsilon()

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** Procedure to introduce and remove epsilon tensor simplifying chains of
** 3 gamma matrices that naturally don't dissapear after 'diracequation'
** Begun on 19/08/03


** First, if we have still some product of three gammas, we will reduce
** them by including the epsilon tensor:
#call usegamma5()

#do line=1,`EXTFERMICURRENTS'
id gamma(`line',mu1?)*gamma(`line',mu2?)*gamma(`line',mu3?)=
  +gamma(`line',mu1)*d_(mu2,mu3)
  -gamma(`line',mu2)*d_(mu1,mu3)
  +gamma(`line',mu3)*d_(mu1,mu2)
  -(1)*i_*eps(mu1,mu2,mu3,ro`line')*gamma(`line',ro`line')*gamma5(`line');
#enddo

** We kill immediately al zero epsilon tensor, for index and for vectors
** (we do it separately since simbol doesn't work)
id eps(?a,mu0?,?b,mu0?,?c)=0;
id eps(?a,k0?,?b,k0?,?c)=0;

#call pushgamma5()
b gamma,omega,ident,gamma5,eps;
.sort
keep brackets;
#call contractepsilon()

** We put the ro's at the end
id eps(ro0?ro,mu1?,mu2?,mu3?)=-eps(mu1,mu2,mu3,ro0);
id eps(mu1?,ro0?ro,mu2?,mu3?)=+eps(mu1,mu2,mu3,ro0);
id eps(mu1?,mu2?,ro0?ro,mu3?)=-eps(mu1,mu2,mu3,ro0);


** So we are ready to dismiss again the epsilon tensor, but
** the following condition is important:
** If there are two gammas in a fermion chain that match the eps indices,
** then we have to place it there:

** NOT A GENERAL CASE, MU1,MU2 SHOULD BE AT THE BEGINNING IN EPS!
id gamma(line?,mu1?)*gamma(line?,mu2?)*eps(mu1?,mu2?,mu3?,mu4?)=-i_*
  ( 2*d_(mu3,mu4) - 2*gamma(line,mu3)*gamma(line,mu4) )*gamma5(line);

id gamma(line?,mu1?)*gamma(line?,mu2?)*eps(mu2?,mu1?,mu3?,mu4?)=-i_*
  (-2*d_(mu3,mu4) + 2*gamma(line,mu3)*gamma(line,mu4) )*gamma5(line);



#do line=1,`EXTFERMICURRENTS'
id eps(mu1?,mu2?,mu3?,ro`line')*gamma(`line',ro`line')=i_*
               (+gamma(`line',mu1)*gamma(`line',mu2)*gamma(`line',mu3)
                -gamma(`line',mu1)*d_(mu2,mu3)
                +gamma(`line',mu2)*d_(mu1,mu3)
                -gamma(`line',mu3)*d_(mu1,mu2)
               )*gamma5(`line');
#enddo

#call pushgamma5()
*#call useomegas()
*#call pushomegas()

#endprocedure

*$Id: threegammastoepsilon.prc,v 1.4 2004/10/08 14:28:12 alorca Exp $
