C File <a0w.F> containing the A0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function A0w(index,cM1S)
C-----------------------------------------------------------------------
      implicit none
      integer index
      double complex cM1S

      double complex A0w_ff,A0waa0,A0waa(2),A0i

      integer i
      double precision widthalltogether,minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
*#include <looptools.h>
C-----------------------------------------------------------------------
*JUST to remember what index is related with which function, added bb's
*#define aa0 1
*#define aa00 2
C-----------------------------------------------------------------------
C If we don't deal with a finite width, lets call looptools
      widthalltogether=DIMAG(cM1S)
      minmass=DBLE(cM1S)
      if (.NOT.lwidth) then
        A0w=A0i(index,DBLE(cM1S))
        return
      endif
C-----------------------------------------------------------------------
C Normal computation for B_0
c      A0waa(1)=A0waa0(cM1S)
      A0waa(1)=A0w_ff(cM1S)
C-----------------------------------------------------------------------
C This does not contain multiplicative factor 1/18
      A0waa(2) = 2*cM1S*A0waa(1)+cM1S**2
      A0waa(2) = A0waa(2)/8
C-----------------------------------------------------------------------
      do i=1,2
        if (index.EQ.i) A0w=A0waa(i)
      enddo
C-----------------------------------------------------------------------
      return
      end
C***********************************************************************


      double complex function A0i(index,M1S)

      implicit none
      integer index
      double precision M1S
      double complex A0
C-----------------------------------------------------------------------
      if (index.EQ.1) then
        A0i=A0(M1S)
c      elseif (index.EQ.2) then
c        A0i=A00(M1S)
      else
        print *,'A0i: Wrong index'
      endif
C-----------------------------------------------------------------------
      return
      end
CC $Id: a0w.F,v 1.2 2004/10/07 15:05:11 alorca Exp $
