** Function CDLOGIE (cdlogie.f)
** This function calculates the Log(y,n)  where the argument 'y' is
** double precision but contains some arbitrarily small imaginary part
** n*i*epsilon either positive (n=1,2,..) or negative (n=-1,-2,...).

C This file is part of aITALC
C Copyright (C) 2002 Alejandro Lorca <alejandro.lorca@desy.de>

      double complex function CDLOGIE(y,n)
      implicit none
      double precision y, epsilon
      double complex ipi
      integer n
      parameter ( ipi=(0d0,3.14159265358979323d0) )
      data epsilon /1d-3/

      if (y.gt.0d0) then
        CDLOGIE= dlog(y)
      else if (y.lt.0d0) then
        CDLOGIE= dlog(-y) + n*ipi
      else
        print *,'Warning, cdlogie(ie) with epsilon argument!!!'
        stop
      endif

      end
